/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.aufgabe.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.aufgabe.entity.AufgabeKommentar;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractAufgabeKommentarSearch {

  @Inject
  protected transient AufgabeKommentarExtendedDAO dao;

  public AbstractAufgabeKommentarSearch() {
    super();
  }

  public List<AufgabeKommentar> getSearchResult(AufgabeKommentarSearchParameters searchParameters, EagerLoadingCollector<AufgabeKommentar> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<AufgabeKommentar> querySearchResult(AufgabeKommentarSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
